package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("Rational")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class Rational implements Marshallable {
	private long numerator;
	private long denominator;

    //
	public long getNumerator() {
	    return numerator;
	}
	public void setNumerator(final long value) {
	    this.numerator = value;
	}

	public Rational numerator(final long value) {
	    setNumerator(value);
	    return this;
	}
	public long getDenominator() {
	    return denominator;
	}
	public void setDenominator(final long value) {
	    this.denominator = value;
	}

	public Rational denominator(final long value) {
	    setDenominator(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.numerator == 0)) {
            marshaller.writeUint(1, this.numerator);
        }
        if (!(this.denominator == 0)) {
            marshaller.writeUint(2, this.denominator);
        }
        return marshaller.array();
    }
}
